//----------------------------------------------------------------------//
// NyanFi																//
//  .nyanfi t@C̐ݒ												//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "CmdListDlg.h"
#include "DotDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDotNyanDlg *DotNyanDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TDotNyanDlg::TDotNyanDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::FormCreate(TObject *Sender)
{
	UserModule->SetUsrPopupMenu(this);

	PathMaskComboBox->Tag = CBTAG_HISTORY;
	GrepMaskComboBox->Tag = CBTAG_HISTORY;

	UnicodeString hntstr = LoadUsrMsg(USTR_HintMltSepSC);
	PathMaskComboBox->Hint = hntstr;
	GrepMaskComboBox->Hint = hntstr;

	ColBufList	= new TStringList();
	InheritList = new TStringList();

	set_ComboBoxText(ColorComboBox,
		_T("Color_bgDirInf=fBNg̔wiF\n")
		_T("Color_fgDirInf=fBNg̕F\n")
		_T("Color_bgDrvInf=hCu̔wiF\n")
		_T("Color_fgDrvInf=hCu̕F\n")
		_T("Color_Cursor=CJ[\̐F\n")
		_T("Color_selItem=Iڂ̔wiF\n"));

	SwatchPanel = new UsrSwatchPanel(this);
	SwatchPanel->Parent = this;
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::FormShow(TObject *Sender)
{
	SwatchPanel->SetPanelSize16x8(15);
	SwatchPanel->Left = ColGroupBox->Left + ColGroupBox->Width - SwatchPanel->Width;
	SwatchPanel->Top  = ColGroupBox->Top + ColGroupBox->Height;

	set_ComboBox_AutoComp(this);

	//^Cgo[ݒ
	HFONT hFont = NULL;
	NONCLIENTMETRICS nc_metrics = {sizeof(NONCLIENTMETRICS)};
	if (::SystemParametersInfo(SPI_GETNONCLIENTMETRICS, nc_metrics.cbSize, &nc_metrics, 0))
		hFont = ::CreateFontIndirect(&nc_metrics.lfCaptionFont);
	std::unique_ptr<TFont> titFont(new TFont());
	if (hFont) titFont->Handle = hFont; else titFont->Assign(DialogFont);
	Caption = get_MiniPathName(DotNyanName + " ̐ݒ", ClientWidth - ScaledInt(48, this), titFont.get());

	IniFile->LoadComboBoxItems(PathMaskComboBox, _T("DotMaskHistory"));
	IniFile->LoadComboBoxItems(GrepMaskComboBox, _T("GrepMaskHistory"));

	ColBufList->Text =
		"Color_bgDirInf=\n"
		"Color_fgDirInf=\n"
		"Color_bgDrvInf=\n"
		"Color_fgDrvInf=\n"
		"Color_Cursor=\n"
		"Color_selItem=\n";

	NyanExists = file_exists(DotNyanName);
	if (NyanExists) {
		std::unique_ptr<TStringList> cfg_lst(new TStringList());
		load_text_ex(DotNyanName, cfg_lst.get());
		UnicodeString vstr = cfg_lst->Values["SortMode"];
		SortRadioGroup->ItemIndex = vstr.IsEmpty()? 0 : SortIdStr.Pos(vstr[1]);

		SetOderOption(cfg_lst.get());

		SoundEdit->Text			 = cfg_lst->Values["PlaySound"];
		BgImgEdit->Text			 = cfg_lst->Values["BgImage"];
		UnicodeString tmp		 = cfg_lst->Values["ExeCommands"];
		remove_top_AT(tmp);
		ExeCmdsEdit->Text		 = tmp;
		HandledCheckBox->Checked = ListVal_equal_1(cfg_lst.get(), _T("Handled"));
		HideCheckBox->Checked    = (file_GetAttr(DotNyanName) & faHidden);
	}
	else {
		SortRadioGroup->ItemIndex = 0;
		NoOderCheckBox->Checked	  = true;
		NoOderCheckBoxClick(NULL);

		HideRadioGroup->ItemIndex = 0;
		SysRadioGroup->ItemIndex  = 0;
		SizeRadioGroup->ItemIndex = 0;
		IconRadioGroup->ItemIndex = 0;
		SyncRadioGroup->ItemIndex = 0;

		PathMaskComboBox->Text	  = EmptyStr;
		GrepMaskComboBox->Text	  = EmptyStr;
		ListWdEdit->Text		  = EmptyStr;
		SoundEdit->Text 		  = EmptyStr;
		BgImgEdit->Text 		  = EmptyStr;
		DescEdit->Text			  = EmptyStr;
		ExeCmdsEdit->Text		  = EmptyStr;
		HandledCheckBox->Checked  = false;
	}

	//ʂ狭IɌpe擾
	InheritList->Clear();
	UnicodeString inam = get_dotNaynfi(ExtractFilePath(DotNyanName), true, true);
	if (file_exists(inam)) {
		load_text_ex(inam, InheritList);
		InheritLabel->Caption = UnicodeString().sprintf(_T("[%s] p\"),
									get_MiniPathName(ExtractFileDir(inam), 400, Font).c_str());
	}

	SetDarkWinTheme(this);
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::FormDestroy(TObject *Sender)
{
	delete ColBufList;
	delete InheritList;
}

//---------------------------------------------------------------------------
//ݒRg[ɔf
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::SetOderOption(TStringList *lst)
{
	NoOderCheckBox->Checked = ListVal_is_empty(lst, _T("NaturalOrder")) &&
							  ListVal_is_empty(lst, _T("DscNameOrder")) &&
							  ListVal_is_empty(lst, _T("SmallOrder")) &&
							  ListVal_is_empty(lst, _T("OldOrder")) &&
							  ListVal_is_empty(lst, _T("DscAttrOrder"));
	NoOderCheckBoxClick(NULL);
	if (!NoOderCheckBox->Checked) {
		NaturalCheckBox->Checked = ListVal_equal_1(lst, _T("NaturalOrder"));
		DscNameCheckBox->Checked = ListVal_equal_1(lst, _T("DscNameOrder"));
		SmallCheckBox->Checked	 = ListVal_equal_1(lst, _T("SmallOrder"));
		OldCheckBox->Checked	 = ListVal_equal_1(lst, _T("OldOrder"));
		DscAttrCheckBox->Checked = ListVal_equal_1(lst, _T("DscAttrOrder"));
	}

	int n;
	n = get_ListIntVal(lst, _T("ShowHideAtr"),   -1);	HideRadioGroup->ItemIndex = (n==1)? 1 : (n==0)? 2 : 0;
	n = get_ListIntVal(lst, _T("ShowHideAtr"),   -1);	HideRadioGroup->ItemIndex = (n==1)? 1 : (n==0)? 2 : 0;
	n = get_ListIntVal(lst, _T("ShowSystemAtr"), -1);	SysRadioGroup->ItemIndex  = (n==1)? 1 : (n==0)? 2 : 0;
	n = get_ListIntVal(lst, _T("ShowByteSize"),  -1);	SizeRadioGroup->ItemIndex = (n==1)? 1 : (n==0)? 2 : 0;
	n = get_ListIntVal(lst, _T("ShowIcon"),		 -1);	IconRadioGroup->ItemIndex = (n==1)? 1 : (n==0)? 2 : (n==2)? 3 : 0;
	n = get_ListIntVal(lst, _T("SyncLR"),		 -1);	SyncRadioGroup->ItemIndex = (n==1)? 1 : (n==0)? 2 : 0;

	PathMaskComboBox->Text = lst->Values["PathMask"];
	GrepMaskComboBox->Text = lst->Values["GrepMask"];
	ListWdEdit->Text	   = lst->Values["ListWidth"];
	DescEdit->Text		   = lst->Values["Description"];

	SetColorOption(lst);
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::SetColorOption(TStringList *lst)
{
	TStringDynArray n_lst =
		SplitString("Color_bgDirInf|Color_fgDirInf|Color_bgDrvInf|Color_fgDrvInf|Color_Cursor|Color_selItem", "|");
	int idx = -1;
	for (int i=0; i<n_lst.Length; i++) {
		UnicodeString lbuf = lst->Values[n_lst[i]];
		ColBufList->Values[n_lst[i]] = lbuf;
		if ((TColor)lbuf.ToIntDef(clNone)!=clNone && idx==-1) idx = i;
	}

	ColorComboBox->ItemIndex = idx;
	ColorComboBox->Repaint();
}

//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::NoOderCheckBoxClick(TObject *Sender)
{
	if (NoOderCheckBox->Checked) {
		NaturalCheckBox->Checked = FlOdrNatural[CurListTag];
		DscNameCheckBox->Checked = FlOdrDscName[CurListTag];
		SmallCheckBox->Checked	 = FlOdrSmall[CurListTag];
		OldCheckBox->Checked	 = FlOdrOld[CurListTag];
		DscAttrCheckBox->Checked = FlOdrDscAttr[CurListTag];
	}
}

//---------------------------------------------------------------------------
//TEh̎Q
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::RefSndBtnClick(TObject *Sender)
{
	UnicodeString inidir = def_if_empty(ExtractFileDir(to_absolute_name(SoundEdit->Text)), ExePath);
	UserModule->PrepareOpenDlg(_T("TEht@C̎w"), F_FILTER_WAV, NULL, inidir);
	if (UserModule->OpenDlgToEdit(SoundEdit, true)) play_sound(SoundEdit->Text);
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::TestSndBtnClick(TObject *Sender)
{
	play_sound(SoundEdit->Text);
}

//---------------------------------------------------------------------------
//wi摜̎Q
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::RefImgBtnClick(TObject *Sender)
{
	UserModule->OpenImgDlg->Title = "wi摜̎w";
	UserModule->SetOpenImgFilter(BgImgEdit->Text);
	UserModule->OpenImgDlg->InitialDir = to_absolute_name(ExtractFilePath(BgImgEdit->Text), ExePath);
	UserModule->OpenImgDlg->FileName   = EmptyStr;
	UserModule->OpenImgDlgToEdit(BgImgEdit, true);
}

//---------------------------------------------------------------------------
//zF
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::ColorComboBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
	TComboBox *cp = (TComboBox*)Control;
	TCanvas   *cv = cp->Canvas;
	int yp = Rect.Top + get_TopMargin(cv);

	UnicodeString col_nam = cp->Items->Names[Index];
	UnicodeString vbuf	  = cp->Items->ValueFromIndex[Index];

	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);
	cv->TextOut(Rect.Left + ScaledIntX(34), yp, vbuf);

	//J[
	TRect rc = Rect;  rc.Right = rc.Left + ScaledIntX(30);
	cv->Brush->Color = (TColor)ColBufList->Values[col_nam].ToIntDef(clNone);
	if (cv->Brush->Color!=clNone) {
		cv->FillRect(rc);
	}
	else {
		cv->Brush->Color = get_PanelColor();
		cv->FillRect(rc);
		out_Text(cv, rc.Left + ScaledIntX(2), yp, _T(""), get_LabelColor());
	}
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::RefColBtnClick(TObject *Sender)
{
	TComboBox *cp = ColorComboBox;
	int idx = cp->ItemIndex;	if (idx==-1) return;

	UnicodeString col_nam = cp->Items->Names[idx];
	UserModule->ColorDlg->Color = (TColor)ColBufList->Values[col_nam].ToIntDef(clBlack);
	if (UserModule->ColorDlg->Execute()) {
		ColBufList->Values[col_nam] = IntToStr(UserModule->ColorDlg->Color);
		cp->Repaint();
	}
}
//---------------------------------------------------------------------------
//X|Cg
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::SpuitImageMouseDown(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	TComboBox *cp = ColorComboBox;
	if (Button!=mbLeft || cp->ItemIndex==-1) return;

	//XEHb`ubN
	SetCustomColToSwatch(UserModule->ColorDlg->CustomColors);
	SwatchPanel->Visible = true;
	SwatchPanel->BringToFront();

	TColor col_def = (TColor)ColBufList->Values[cp->Items->Names[cp->ItemIndex]].ToIntDef(clNone);
	UserModule->BeginSpuit(SpuitPanel, SpuitImage, col_def);
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::SpuitImageMouseUp(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	SwatchPanel->Visible = false;

	if (UserModule->SpuitEnabled()) {
		TColor col = UserModule->EndSpuit();
		TComboBox *cp = ColorComboBox;
		if (cp->ItemIndex!=-1) {
			ColBufList->Values[cp->Items->Names[cp->ItemIndex]] = col;
			cp->Repaint();
		}
	}
}
//---------------------------------------------------------------------------
//zF̖
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::DisableColActionExecute(TObject *Sender)
{
	TComboBox *cp = ColorComboBox;
	if (cp->ItemIndex!=-1) {
		ColBufList->Values[cp->Items->Names[cp->ItemIndex]] = IntToStr(clNone);
		cp->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::DisableColActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (ColorComboBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//R}ht@C̎Q
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::RefCmdsBtnClick(TObject *Sender)
{
	if (CmdFileListDlg->ShowToSelect(get_cmdfile(ExeCmdsEdit->Text))==mrOk)
		ExeCmdsEdit->Text = to_relative_name(CmdFileListDlg->CmdFileName);
}

//---------------------------------------------------------------------------
//LZ
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::CancelBtnClick(TObject *Sender)
{
	//X|Cg̃LZ
	if (UserModule->SpuitEnabled()) {
		SwatchPanel->Visible = false;
		UserModule->EndSpuit();
		SpuitImage->Visible = true;
	}
	//
	else ModalResult = mrCancel;
}

//---------------------------------------------------------------------------
//쐬/ύX
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::CreNyanActionExecute(TObject *Sender)
{
	UnicodeString lbuf;

	if (SortRadioGroup->ItemIndex>0)
		lbuf.cat_sprintf(_T("SortMode=%s\r\n"), SortIdStr.SubString(SortRadioGroup->ItemIndex, 1).c_str());

	if (!NoOderCheckBox->Checked) {
		lbuf.cat_sprintf(_T("NaturalOrder=%u\r\n"),	NaturalCheckBox->Checked? 1 : 0);
		lbuf.cat_sprintf(_T("DscNameOrder=%u\r\n"),	DscNameCheckBox->Checked? 1 : 0);
		lbuf.cat_sprintf(_T("SmallOrder=%u\r\n"),	SmallCheckBox->Checked  ? 1 : 0);
		lbuf.cat_sprintf(_T("OldOrder=%u\r\n"),		OldCheckBox->Checked    ? 1 : 0);
		lbuf.cat_sprintf(_T("DscAttrOrder=%u\r\n"),	DscAttrCheckBox->Checked? 1 : 0);
	}

	if (HideRadioGroup->ItemIndex>0) lbuf.cat_sprintf(_T("ShowHideAtr=%u\r\n"),   (HideRadioGroup->ItemIndex==1)? 1 : 0);
	if (SysRadioGroup->ItemIndex>0)  lbuf.cat_sprintf(_T("ShowSystemAtr=%u\r\n"), (SysRadioGroup->ItemIndex==1) ? 1 : 0);
	if (SizeRadioGroup->ItemIndex>0) lbuf.cat_sprintf(_T("ShowByteSize=%u\r\n"),  (SizeRadioGroup->ItemIndex==1)? 1 : 0);
	if (IconRadioGroup->ItemIndex>0) lbuf.cat_sprintf(_T("ShowIcon=%u\r\n"),	  (IconRadioGroup->ItemIndex==1)? 1 :
																				  (IconRadioGroup->ItemIndex==2)? 0 : 2);
	if (SyncRadioGroup->ItemIndex>0) lbuf.cat_sprintf(_T("SyncLR=%u\r\n"),		  (SyncRadioGroup->ItemIndex==1)? 1 : 0);

	if (!PathMaskComboBox->Text.IsEmpty())	{
		lbuf.cat_sprintf(_T("PathMask=%s\r\n"), PathMaskComboBox->Text.c_str());
		add_ComboBox_history(PathMaskComboBox);
	}
	IniFile->SaveComboBoxItems(PathMaskComboBox, _T("DotMaskHistory"));

	if (!GrepMaskComboBox->Text.IsEmpty())	lbuf.cat_sprintf(_T("GrepMask=%s\r\n"), 	GrepMaskComboBox->Text.c_str());
	if (!ListWdEdit->Text.IsEmpty())		lbuf.cat_sprintf(_T("ListWidth=%s\r\n"),	ListWdEdit->Text.c_str());
	if (!SoundEdit->Text.IsEmpty())			lbuf.cat_sprintf(_T("PlaySound=%s\r\n"),	SoundEdit->Text.c_str());
	if (!BgImgEdit->Text.IsEmpty())			lbuf.cat_sprintf(_T("BgImage=%s\r\n"),		BgImgEdit->Text.c_str());
	if (!DescEdit->Text.IsEmpty())			lbuf.cat_sprintf(_T("Description=%s\r\n"),	DescEdit->Text.c_str());
	if (!ExeCmdsEdit->Text.IsEmpty())		lbuf.cat_sprintf(_T("ExeCommands=@%s\r\n"),	ExeCmdsEdit->Text.c_str());
	if (HandledCheckBox->Checked)			lbuf += "Handled=1\r\n";

	for (int i=0; i<ColBufList->Count; i++)
		if ((TColor)ColBufList->ValueFromIndex[i].ToIntDef(clNone)!=clNone)
			lbuf.cat_sprintf(_T("%s\r\n"), ColBufList->Strings[i].c_str());

	std::unique_ptr<TStringList> cfg_lst(new TStringList());
	cfg_lst->Text = lbuf;

	//B/VXeUĂۑEĐݒ
	int attr = NyanExists? file_GetAttr(DotNyanName) : faArchive;
	bool chg_atr = (attr & (faHidden | faSysFile));
	if (chg_atr) file_SetAttr(DotNyanName, faArchive);

	if (saveto_TextUTF8(DotNyanName, cfg_lst.get())) {
		if (HideCheckBox->Checked) attr |= faHidden; else attr &= ~faHidden;
		file_SetAttr(DotNyanName, attr);
		cursor_HourGlass(); Sleep(250); cursor_Default();
		ModalResult = mrOk;
	}
	else msgbox_ERR(LoadUsrMsg(USTR_FaildSave, get_dotNaynfi()));
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::CreNyanActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Caption = NyanExists? "ύX" : "쐬";

	NaturalCheckBox->Enabled = !NoOderCheckBox->Checked;
	DscNameCheckBox->Enabled = !NoOderCheckBox->Checked;
	SmallCheckBox->Enabled	 = !NoOderCheckBox->Checked;
	OldCheckBox->Enabled	 = !NoOderCheckBox->Checked;
	DscAttrCheckBox->Enabled = !NoOderCheckBox->Checked;

	ExeCmdsEdit->Enabled = PermitDotCmds;
	RefCmdsBtn->Enabled  = PermitDotCmds;
	HandledCheckBox->Enabled = ExeCmdsEdit->Text.IsEmpty();
	if (!ExeCmdsEdit->Text.IsEmpty()) HandledCheckBox->Checked = false;
	if (!UserModule->SpuitEnabled()) SpuitImage->Visible = (ColorComboBox->ItemIndex!=-1);

	bool inherit = (InheritList->Count>0);
	InhSndBtn->Enabled	= inherit;
	InhImgBtn->Enabled	= inherit;
	InhColBtn->Enabled	= inherit;
	InhCmdBtn->Enabled	= inherit;
	InheritBtn->Enabled = inherit;
}

//---------------------------------------------------------------------------
//p
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::InhSndBtnClick(TObject *Sender)
{
	SoundEdit->Text = InheritList->Values["PlaySound"];
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::InhImgBtnClick(TObject *Sender)
{
	BgImgEdit->Text = InheritList->Values["BgImage"];
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::InhColBtnClick(TObject *Sender)
{
	SetColorOption(InheritList);
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::InhCmdBtnClick(TObject *Sender)
{
	UnicodeString tmp = InheritList->Values["ExeCommands"];
	remove_top_AT(tmp);
	ExeCmdsEdit->Text = tmp;
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::InheritBtnClick(TObject *Sender)
{
	UnicodeString vstr;
	vstr = InheritList->Values["SortMode"];		 SortRadioGroup->ItemIndex = vstr.IsEmpty()? 0 : SortIdStr.Pos(vstr[1]);

	SetOderOption(InheritList);

	HandledCheckBox->Checked = equal_1(InheritList->Values["Handled"]);
	HideCheckBox->Checked    = (file_GetAttr(DotNyanName) & faHidden);

	InhSndBtnClick(NULL);
	InhImgBtnClick(NULL);
	InhCmdBtnClick(NULL);
}

//---------------------------------------------------------------------------
//폜
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::DelNyanActionExecute(TObject *Sender)
{
	UnicodeString msg = make_LogHdr(_T("DELETE"), DotNyanName);
	try {
		if (msgbox_Sure(LoadUsrMsg(USTR_DeleteQ, get_dotNaynfi()), SureDelete)) {
			if (ForceDel && !set_FileWritable(DotNyanName))	Abort();
			if (!delete_File(DotNyanName, DelUseTrash))	 	Abort();
			AddLog(msg);
			cursor_HourGlass(); Sleep(250); cursor_Default();
			ModalResult = mrOk;
		}
	}
	catch (EAbort &e) {
		set_LogErrMsg(msg);
		AddLog(msg);
	}
}
//---------------------------------------------------------------------------
void __fastcall TDotNyanDlg::DelNyanActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = NyanExists;
}
//---------------------------------------------------------------------------
